=== src/CMakeLists.txt ===
################################################################################
#
# MIT License
#
# Copyright (c) 2017 Advanced Micro Devices, Inc.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
#
################################################################################

cmake_policy(SET CMP0057 NEW)

include(ExportHeader)
if(MIOPEN_ENABLE_SQLITE)
    add_subdirectory(sqlite)
endif()

# Truncation rounding or (default) rounding to nearest even (RNE) is enabled.
# This switch controls two related but different aspects of MIOpen behavior
# 1.  How host code performs conversions of float to bfloat16, important only
#     for testing.
# 2.  How BF16 kernels (which are kind of mixed-precision now and expected to
#     remain in the future)  perform final conversion (and rounding) of FP32
#     to BF16 results. This affects the main functionality of the library.
option( MIOPEN_USE_RNE_BFLOAT16 "Sets rounding scheme for bfloat16 type" ON )
option( MIOPEN_FP8_IEEE_EXPONENT_BIAS "Sets the FP8 exponent bias to IEEE" OFF)
option( MIOPEN_FP8_CLIPPING "Sets the FP8 clipping" ON)

option( MIOPEN_FP8_CLIPPING "Sets the FP8 clipping" ON)

configure_file("${PROJECT_SOURCE_DIR}/include/miopen/config.h.in" "${PROJECT_BINARY_DIR}/include/miopen/config.h")

# configure a header file to pass the CMake version settings to the source, and package the header files in the output archive
configure_file( "${PROJECT_SOURCE_DIR}/include/miopen/version.h.in" "${PROJECT_BINARY_DIR}/include/miopen/version.h" )

if(BUILD_FILE_REORG_BACKWARD_COMPATIBILITY)
#Copy header to Build Dir for generating backward compatibility
configure_file( "${PROJECT_SOURCE_DIR}/include/miopen/miopen.h" "${PROJECT_BINARY_DIR}/include/miopen/miopen.h" )
endif()

message( STATUS "MIOpen_VERSION= ${MIOpen_VERSION}" )
if(NOT MIOPEN_GENERATOR_IS_MULTI_CONFIG)
    message( STATUS "CMAKE_BUILD_TYPE= ${CMAKE_BUILD_TYPE}" )
endif()

# This is incremented when the ABI to the library changes
set( MIOpen_SOVERSION 1.0 )

function(add_kernels FILE_NAME VAR_PREFIX VAR_SUFFIX KERNEL_FILES)
    set(INIT_KERNELS_LIST)
    set(KERNELS_DECLS)
    foreach(KERNEL_FILE ${KERNEL_FILES})
        set_property(DIRECTORY APPEND PROPERTY CMAKE_CONFIGURE_DEPENDS ${KERNEL_FILE})
        get_filename_component(KERNEL_FILENAME ${KERNEL_FILE} NAME)
        get_filename_component(BASE_NAME ${KERNEL_FILE} NAME_WE)
        string(TOUPPER "${BASE_NAME}" KEY_NAME)
        string(MAKE_C_IDENTIFIER "${KEY_NAME}" VAR_NAME)
        string(APPEND KERNELS_DECLS "extern const size_t ${VAR_PREFIX}${VAR_NAME}${VAR_SUFFIX}_SIZE;\n")
        string(APPEND KERNELS_DECLS "extern const char ${VAR_PREFIX}${VAR_NAME}${VAR_SUFFIX}[];\n")
        list(APPEND INIT_KERNELS_LIST "    { \"${KERNEL_FILENAME}\", { ${VAR_PREFIX}${VAR_NAME}${VAR_SUFFIX}, ${VAR_PREFIX}${VAR_NAME}${VAR_SUFFIX}_SIZE } }")
    endforeach()
    string(REPLACE ";" ",\n" INIT_KERNELS "${INIT_KERNELS_LIST}")
    configure_file(kernels/${FILE_NAME}.in ${PROJECT_BINARY_DIR}/${FILE_NAME})
endfunction()

set( MIOpen_Source
    activ/problem_description.cpp
    activ_api.cpp
    adam/problem_description.cpp
    adam_api.cpp
    addlayernorm_api.cpp
    api/find2_0_commons.cpp
    base64.cpp
    batch_norm.cpp
    batch_norm_api.cpp
    batchnorm/problem_description.cpp
    buffer_info.cpp
    cat_api.cpp
    cat/problem_description.cpp
    check_numerics.cpp
    conv/invokers/gcn_asm_1x1u.cpp
    conv/invokers/gcn_asm_1x1u_ss.cpp
    conv/invokers/gcn_asm_1x1u_us.cpp
    conv/invokers/gcn_asm_wino.cpp
    conv/invokers/gen_x_w_y_pad.cpp
    conv/invokers/impl_gemm.cpp
    conv/invokers/impl_gemm_dynamic.cpp
    conv/invokers/ocl_wrw_rdc.cpp
    conv/kernel_interface/winograd_kernel_interface.cpp
    conv/problem_description.cpp
    conv/solver_finders.cpp
    conv_algo_name.cpp
    convolution.cpp
    convolution_api.cpp
    ctc.cpp
    ctc_api.cpp
    db.cpp
    db_record.cpp
    driver_arguments.cpp
    dropout.cpp
    dropout_api.cpp
    env.cpp
    execution_context.cpp
    expanduser.cpp
    fin/fin_interface.cpp
    find_controls.cpp
    find_db.cpp
    fused_api.cpp
    fusion.cpp
    fusion/problem_description.cpp
    generic_search.cpp
    getitem_api.cpp
    glu/problem_description.cpp
    glu_api.cpp
    graphapi/convolution.cpp
    graphapi/conv_bias_res_add_activ_forward_executor.cpp
    graphapi/engine.cpp
    graphapi/enginecfg.cpp
    graphapi/engineheur.cpp
    graphapi/execution_plan.cpp
    graphapi/find_engine.cpp
    graphapi/graphapi.cpp
    graphapi/matmul.cpp
    graphapi/opgraph.cpp
    graphapi/pointwise.cpp
    graphapi/reduction.cpp
    graphapi/reshape.cpp
    graphapi/rng.cpp
    graphapi/tensor.cpp
    graphapi/variant_pack.cpp
    groupnorm_api.cpp
    groupnorm/problem_description.cpp
    handle_api.cpp
    invoker_cache.cpp
    getitem/problem_description.cpp
    kernel_build_params.cpp
    kernel_warnings.cpp
    kthvalue/problem_description.cpp
    kthvalue_api.cpp
    layernorm_api.cpp
    layernorm/problem_description.cpp
    load_file.cpp
    lock_file.cpp
    logger.cpp
    lrn_api.cpp
    mha/mha_descriptor.cpp
    mha/problem_description.cpp
    multimarginloss/problem_description.cpp
    multimarginloss_api.cpp
    op_args.cpp
    operator.cpp
    performance_config.cpp
    pooling/problem_description.cpp
    pooling_api.cpp
    prelu/problem_description.cpp
    prelu_api.cpp
    problem.cpp
    process.cpp
    ramdb.cpp
    readonlyramdb.cpp
    reducecalculation_api.cpp
    reduceextreme_api.cpp
    reducetensor.cpp
    reducetensor_api.cpp
    reduce/problem_description.cpp
    rnn.cpp
    rnn_api.cpp
    rnn/rnn_util.cpp
    rnn/selector.cpp
    rnn/Solutions/rnn_transformer.cpp
    rnn/Solutions/Base/fw_data_modular.cpp
    rnn/Solutions/Base/bw_weights_modular.cpp
    rnn/Solutions/Base/bw_data_modular.cpp
    rnn/Solutions/fwd_s_stream.cpp
    rnn/Solutions/bwd_s_stream.cpp
    rnn/Solutions/bwd_multi_stream.cpp
    rnn/Solutions/bww_s_steam.cpp
    rnn/Solutions/bww_multi_stream.cpp
    rope_api.cpp
    rope/problem_description.cpp
    scalar.cpp
    softmarginloss/problem_description.cpp 
    softmarginloss_api.cpp
    softmax.cpp
    softmax_api.cpp
    softmax/problem_description.cpp
    solution.cpp
    solver.cpp
    solver/activ/bwd_0.cpp
    solver/activ/bwd_1.cpp
    solver/activ/fwd_0.cpp
    solver/activ/fwd_1.cpp
    solver/adam/adam.cpp
    solver/adam/transformers_adam_w.cpp
    solver/batchnorm/backward_ck.cpp
    solver/batchnorm/backward_per_activation.cpp
    solver/batchnorm/backward_per_activation_fused.cpp
    solver/batchnorm/backward_spatial_multiple.cpp
    solver/batchnorm/backward_spatial_single.cpp
    solver/batchnorm/forward_inference.cpp
    solver/batchnorm/forward_inference_ck.cpp
    solver/batchnorm/forward_inference_fused.cpp
    solver/batchnorm/forward_per_activation.cpp
    solver/batchnorm/forward_per_activation_fused.cpp
    solver/batchnorm/forward_spatial_multiple.cpp
    solver/batchnorm/forward_spatial_single.cpp
    solver/batchnorm/forward_training_ck.cpp
    solver/cat/forward_cat.cpp
    solver/conv/conv_asm_1x1u.cpp
    solver/conv/conv_asm_1x1u_stride2.cpp
    solver/conv/conv_asm_3x3u.cpp
    solver/conv/conv_asm_5x10u2v2b1.cpp
    solver/conv/conv_asm_5x10u2v2f1.cpp
    solver/conv/conv_asm_7x7c3h224w224k64u2v2p3q3f1.cpp
    solver/conv/conv_asm_dir_BwdWrW1x1.cpp
    solver/conv/conv_asm_dir_BwdWrW3x3.cpp
    solver/conv/conv_asm_implicit_gemm_bwd_v4r1_dynamic.cpp
    solver/conv/conv_asm_implicit_gemm_gtc_bwd.cpp
    solver/conv/conv_asm_implicit_gemm_gtc_bwd_nhwc.cpp
    solver/conv/conv_asm_implicit_gemm_gtc_fwd.cpp
    solver/conv/conv_asm_implicit_gemm_gtc_fwd_nhwc.cpp
    solver/conv/conv_asm_implicit_gemm_gtc_fwd_nchwc.cpp
    solver/conv/conv_asm_implicit_gemm_gtc_perf_config.cpp
    solver/conv/conv_asm_implicit_gemm_gtc_wrw_nhwc.cpp
    solver/conv/conv_asm_implicit_gemm_v4r1_dynamic.cpp
    solver/conv/conv_asm_implicit_gemm_wrw_gtc_dynamic_xdlops.cpp
    solver/conv/conv_asm_implicit_gemm_wrw_v4r1_dynamic.cpp
    solver/conv/conv_bin_wino3x3U.cpp
    solver/conv/conv_bin_winoRxS.cpp
    solver/conv/conv_ck_igemm_fwd_v6r1_dlops_nchw.cpp
    solver/conv/conv_direct_naive_conv.cpp
    solver/conv/conv_direct_naive_conv_bwd.cpp
    solver/conv/conv_direct_naive_conv_fwd.cpp
    solver/conv/conv_direct_naive_conv_wrw.cpp
    solver/conv/conv_hip_implicit_gemm_bwd_data_xdlops.cpp
    solver/conv/conv_hip_implicit_gemm_bwd_v1r1.cpp
    solver/conv/conv_hip_implicit_gemm_bwd_v1r1_xdlops.cpp
    solver/conv/conv_hip_implicit_gemm_bwd_v4r1.cpp
    solver/conv/conv_hip_implicit_gemm_bwd_v4r1_xdlops.cpp
    solver/conv/conv_hip_implicit_gemm_fwd_v4r1.cpp
    solver/conv/conv_hip_implicit_gemm_fwd_v4r4.cpp
    solver/conv/conv_hip_implicit_gemm_fwd_v4r4_xdlops.cpp
    solver/conv/conv_hip_implicit_gemm_fwd_v4r4_xdlops_padded_gemm.cpp
    solver/conv/conv_hip_implicit_gemm_fwd_v4r5_xdlops.cpp
    solver/conv/conv_hip_implicit_gemm_fwd_xdlops.cpp
    solver/conv/conv_hip_implicit_gemm_grouped_fwd_xdlops.cpp
    solver/conv/conv_hip_implicit_gemm_grouped_bwd_xdlops.cpp
    solver/conv/conv_hip_implicit_gemm_grouped_wrw_xdlops.cpp
    solver/conv/conv_hip_implicit_gemm_3d_grouped_fwd_xdlops.cpp
    solver/conv/conv_hip_implicit_gemm_3d_grouped_wrw_xdlops.cpp
    solver/conv/conv_hip_implicit_gemm_3d_grouped_bwd_xdlops.cpp
    solver/conv/conv_hip_implicit_gemm_nonxdlops_common.cpp
    solver/conv/conv_hip_implicit_gemm_wrw_v4r4.cpp
    solver/conv/conv_hip_implicit_gemm_wrw_v4r4_xdlops.cpp
    solver/conv/conv_hip_implicit_gemm_wrw_v4r4_xdlops_padded_gemm.cpp
    solver/conv/conv_MP_bidirectional_winograd.cpp
    solver/conv/conv_mlir_igemm_bwd.cpp
    solver/conv/conv_mlir_igemm_bwd_xdlops.cpp
    solver/conv/conv_mlir_igemm_fwd.cpp
    solver/conv/conv_mlir_igemm_fwd_xdlops.cpp
    solver/conv/conv_mlir_igemm_wrw.cpp
    solver/conv/conv_mlir_igemm_wrw_xdlops.cpp
    solver/conv/conv_multipass_wino3x3WrW.cpp
    solver/conv/conv_ocl_dir2D_bwdWrW_1x1.cpp
    solver/conv/conv_ocl_dir2D_bwdWrW_2.cpp
    solver/conv/conv_ocl_dir2D_bwdWrW_53.cpp
    solver/conv/conv_ocl_dir2D11x11.cpp
    solver/conv/conv_ocl_dir2Dfwd.cpp
    solver/conv/conv_ocl_dir2Dfwd_exhaustive_search.cpp
    solver/conv/conv_ocl_dir2Dfwd1x1.cpp
    solver/conv/conv_ocl_dir2Dfwdgen.cpp
    solver/conv/conv_wino_fury_RxS.cpp
    solver/conv/conv_winoRxS.cpp
    solver/conv/fft.cpp
    solver/conv/gemm.cpp
    solver/conv/gemm_bwd.cpp
    solver/conv/gemm_common.cpp
    solver/conv/gemm_wrw.cpp
    solver/conv_asm_1x1u_bias_activ_fused.cpp
    solver/conv_bin_winoRxS_fused.cpp
    solver/conv_ck_igemm_fwd_bias_activ_fused.cpp
    solver/conv_ck_igemm_fwd_bias_res_add_activ_fused.cpp
    solver/conv_ocl_dir2Dfwd_fused.cpp
    solver/conv_winoRxS_fused.cpp
    solver/glu/backward_glu.cpp
    solver/glu/forward_glu.cpp
    solver/groupnorm/forward_groupnorm.cpp
    solver/getitem/backward_getitem.cpp
    solver/kthvalue/forward_kthvalue.cpp
