=== src/sqlite/CMakeLists.txt ===
################################################################################
#
# MIT License
#
# Copyright (c) 2020 Advanced Micro Devices, Inc.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
#
################################################################################

add_library(
    sqlite_memvfs
    OBJECT
        memvfs.cpp
)

target_compile_options(sqlite_memvfs PRIVATE
        $<$<CXX_COMPILER_ID:Clang>:-Wno-everything>
        $<$<CXX_COMPILER_ID:GNU>:-w>)

target_link_libraries(sqlite_memvfs PRIVATE SQLite::SQLite3)
# set_target_properties(
#     sqlite_memvfs
#     PROPERTIES
#          CXX_CLANG_TIDY ""
# )
set_property(TARGET sqlite_memvfs PROPERTY POSITION_INDEPENDENT_CODE ON)
