=== src/composable_kernel/host/CMakeLists.txt ===
add_subdirectory(host_tensor)
add_subdirectory(driver_offline)
