=== debian/changelog ===
miopen (6.4.3+dfsg-1~exp1) experimental; urgency=medium

  * Set standards version to 4.7.2
  * Add dependancy on libhipblas-dev
  * Add dependancy on librocrand-dev
  * Fix exec permissions for files in db directory
  * Set MIOPEN_USE_COMGR=OFF for MIOPEN_USE_HIPRTC=OFF
  * Update patch remove-assembly-code-integration
  * Define HIP_OC_COMPILER
  * Add patch for bug in test
  * Add myself to uploaders
  * Rebase patch for 6.4.3
  * New upstream version 6.4.3+dfsg
  * Update watch file for 6.4.x

 -- Christian Bayle <bayle@debian.org>  Fri, 26 Sep 2025 21:26:32 +0200
