=== debian/watch ===
#version=4
#opts="filenamemangle=s%.*/rocm-@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,searchmode=plain,repacksuffix=+dfsg,dversionmangle=auto" \
#    https://api.github.com/repos/ROCm/MIOpen/tags?per_page=100 \
#    https://api.github.com/repos/ROCm/MIOpen/tarball/refs/tags/rocm-@ANY_VERSION@
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,repacksuffix=+dfsg,dversionmangle=auto" \
    https://github.com/rocm/@PACKAGE@/tags?after=rocm-7.0.0 \
    (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz debian
